variables:
  ASSEMBLY_NAME: uMod.WebSockets
  CONFIGURATION: Release
  GIT_DEPTH: 1

stages:
  - build
  - test
  - deploy
  - tag

image: mcr.microsoft.com/dotnet/sdk:latest # always use the latest dotnet image

build:
  stage: build
  cache:
    key: $CI_PIPELINE_ID
    untracked: true
    policy: push
    paths:
      - src/bin/
  script:
    - COMMON_VERSION=$(awk '/<PackageReference Include=\"uMod\.Common\"/{print}' src/$ASSEMBLY_NAME.csproj | awk -F '\"' '/Version=/{print $4}')
    - VERSION=$(awk -F'[<|>]' '/<Version>/{print $3}' src/$ASSEMBLY_NAME.csproj) # get existing version from project
    - NEW_VERSION=${VERSION%.*}.$CI_PIPELINE_IID # add pipeline internal id to version as build number
    - PACKAGE_VERSION=$NEW_VERSION; if [[ ! $CI_COMMIT_REF_SLUG =~ ^(master$|nukeeper-.*) ]]; then PACKAGE_VERSION=$NEW_VERSION-$CI_COMMIT_REF_SLUG; fi # add ref/branch to version
    - META_VERSION=$PACKAGE_VERSION+$CI_PIPELINE_ID # add metadata to version
    - "echo Commit ref name: $CI_COMMIT_REF_SLUG, Package version: $PACKAGE_VERSION, Meta version: $META_VERSION"
    - dotnet build --configuration $CONFIGURATION -p:Version=$META_VERSION # build the project(s)
    - echo $PACKAGE_VERSION >> src/bin/VERSION # store version in file for other stages
    - echo $COMMON_VERSION >> src/bin/COMMON_VERSION

test:
  stage: test
  cache:
    key: $CI_PIPELINE_ID
    policy: pull
  script:
    - dotnet test tests --configuration $CONFIGURATION --no-build # run tests

deploy:
  stage: deploy
  only:
    - branches # only deploy branches, not merge requests or tags
  cache:
    key: $CI_PIPELINE_ID
    policy: pull
    paths:
      - src/bin/
  script:
    - mkdir $ASSEMBLY_NAME
    - declare -a dependencies=(Mono.Options.dll Newtonsoft.Json.dll Fleck.dll)
    - for FILE in ${dependencies[@]}; do cp src/bin/$CONFIGURATION/*/$FILE $ASSEMBLY_NAME; done # copy dependency file(s)
    - cp src/bin/VERSION src/bin/COMMON_VERSION src/bin/$CONFIGURATION/*/uMod.*.dll src/bin/$CONFIGURATION/*/$ASSEMBLY_NAME.runtimeconfig.json src/bin/$CONFIGURATION/*/$ASSEMBLY_NAME.deps.json $ASSEMBLY_NAME # copy build file(s)
  artifacts:
    name: $ASSEMBLY_NAME
    paths:
      - $ASSEMBLY_NAME/
    expire_in: 30 days
